#include "BibliothekMethoden.hpp"
#include <iostream>

void Person::print(){
  std::cout
    << "Person "
    << "(" << this->name
    << "," << this->vorname
    << "," << this->strasse
    << "," << this->ort
    << "," << this->plz
    << ")";
}
void Buch::print(){
  std::cout
    << "Buch"
    << "(" << this->titel 
    << "," << this->autor
    << ")";
}
void Datum::print(){
  std::cout
    << "Datum"
    << "(" << this->tag
    << "," << this->monat
    << "," << this->jahr
    << ")";
}

void Ausleihe::print(){
  std::cout<< "Ausleihe(";
  this->ausleiher->print();
  std::cout<< ",";
  this->ausgeliehenesBuch->print();
  std::cout<< ",";
  this->rueckgabe->print();
  std::cout<< ")";
}

void Datum::umEinenMonatErhoehen(){
  if (this->monat==12) this->jahr = this->jahr+1;

  this->monat=(this->monat%12)+1;

  if (this->tag>28 && this->monat==2)this->tag=28;

  if (this->tag==31)
    switch (this->monat){
      case 4:
      case 6:
      case 9:
      case 11: this->tag=30;
    }
}

void Ausleihe::verlaengere(){
  this->rueckgabe->umEinenMonatErhoehen();
}

bool Ausleihe::ueberfaellig(Datum* heute){
  Datum* d=this->rueckgabe;
  return 
      heute->jahr>d->jahr
   || (heute->jahr==d->jahr && heute->monat>d->monat)
   || (heute->jahr==d->jahr && heute->monat==d->monat 
                            && heute->tag>d->tag);
}

Person::Person
    (std::string name,std::string vorname
    ,std::string strasse,std::string ort,unsigned int plz){
  this->name=name;
  this->vorname=vorname;
  this->strasse=strasse;
  this->ort=ort;
  this->plz=plz;
}

Buch::Buch(std::string titel,std::string autor){
  this->titel=titel;
  this->autor=autor;
}

Datum::Datum
    (short tag,short monat,unsigned int jahr){
  this->tag=tag;
  this->monat=monat;
  this->jahr=jahr;
}

Ausleihe::Ausleihe
    (Person* ausleiher,Buch* ausgeliehenesBuch,Datum* rueckgabe){
  this->ausleiher=ausleiher;
  this->ausgeliehenesBuch=ausgeliehenesBuch;
  this->rueckgabe=rueckgabe;
}

