#include <string>
#include <sstream>
#include "UniPair.hpp"

#include "ToString.hpp"
template <typename A>
class Li:public ToString {
  private:
    A hd;
    Li<A>* tl;
    bool empty;

  public: 
    Li(A hd, Li<A>* tl):empty(false){
      this->hd=hd;
      this->tl=tl;
    }

    Li():empty(true){}

    bool isEmpty(){return empty;}
    A head(){return hd;}    
    Li<A>* tail(){return tl;}

    virtual ~Li(){
      if (!isEmpty()) delete tl;
    }

    Li<A>* clone(){
      if (isEmpty()) return new Li<A>();
      return new Li<A>(head(),tail()->clone());
    }

    Li<A>* operator+(Li<A>* other) {
      if (isEmpty()) return other->clone();
      return new Li<A>(head(),(*tail())+other);
    }

    int size()  {
      if (isEmpty()) return 0;
      return 1+tail()->size();
    }

    bool contains(A el){
      if (isEmpty())return false;
      if (head()==el) return true;
      return tail()->contains(el);
    }


        void forEach(A f(A)){
      for (Li<A>* it=this;!it->isEmpty();it=it->tail())
        it->hd=f(it->head());
    }

    std::string toString(){
      if (isEmpty()) return "[]";
      std::stringstream ss;
      ss<<"["<<this->head();
      for ( Li<A>* it=this->tail()
          ; !it->isEmpty();it=it->tail()){
        ss<<","<<it->head();
      }
      ss<<"]";
      return ss.str();
    }
};

