#include "knoppwidget2.hpp"
#include <QApplication>
#include <iostream>

void KnoppWidget::execute1(){
  std::cout<<"I told you not to push the button"<<std::endl;
}

void KnoppWidget::execute2(){
  std::cout<<"so thats all that happens"<<std::endl;
}

KnoppWidget::KnoppWidget(){
  b1=new QPushButton("do not push this button");
  b2=new QPushButton("oh yeah push this button");

  connect(b1, SIGNAL(pressed(void)),this, SLOT(execute1(void)));
  connect(b2, SIGNAL(pressed(void)),this, SLOT(execute2(void)));

  mainLayout = new QVBoxLayout();
  mainLayout->addWidget(b1);
  mainLayout->addWidget(b2);

  setLayout(mainLayout);
}

KnoppWidget::~KnoppWidget(){
  hide();
  delete mainLayout;
  delete b1;
  delete b2;
}

int main(int argc,char** argv){
  QApplication app(argc,argv);
  KnoppWidget* kw= new KnoppWidget();
  kw->show();

  return app.exec();
}

