#include "Dialogue.hpp"
#include <QApplication>
#include <QVBoxLayout>
Dialogue::Dialogue(DialogueLogic* logic):logic(logic){
  output=new QLabel();
  input=new QLineEdit();
  b=new QPushButton(logic->description().c_str());

  QVBoxLayout* mainLayout = new QVBoxLayout();
  mainLayout->addWidget(input);
  mainLayout->addWidget(b);
  mainLayout->addWidget(output);
  setLayout(mainLayout);
  connect(b   , SIGNAL(pressed(void))
         ,this, SLOT  (execute(void)));
}

void Dialogue::execute(){
  output->setText
    (QString(logic->eval(input->text().toStdString()).c_str()));
  this->repaint();
}

int Dialogue::run(DialogueLogic* logic,int argc,char** argv){
  QApplication app(argc,argv);
  Dialogue* dia=new Dialogue(logic);
  dia->resize(100, 30);  
  dia->show ();     
  return app.exec();
}

