#include "Board.hpp"
#include <QtGui>

Board::Board(std::vector<GeometricObject*>& geos)
                                      :QWidget(0),geos(geos){
  setBackgroundRole(QPalette::Base);
  connect(&timer,SIGNAL(timeout()),this,SLOT(tick()));
  timer.start(25);
}

QSize Board::minimumSizeHint(){return QSize(100, 100);}
QSize Board::sizeHint(){return QSize(400, 300);}

template <typename IT>
void paintIt(IT begin,IT end,QPainter& painter){
    for (;begin!=end;begin++) (*begin)->paintMe(&painter);
}
template <typename IT>
void moveIt(IT begin,IT end){
  for (;begin!=end;begin++) (*begin)->move();
}

void Board::paintEvent(QPaintEvent *){
  QPen pen;
  QPainter painter(this);
  painter.setPen(pen);
 
  paintIt(geos.begin(),geos.end(),painter) ;
}

int Board::showPaintable
    (std::vector<GeometricObject*>& geos,int argc,char **argv){
  QApplication application(argc,argv);
  Board* b = new Board(geos); 
  b->show();
  return application.exec();
}

void Board::tick(){
  moveIt(geos.begin(),geos.end());
  this->repaint();
}

